Bug Hunting Session
Bug 93318 - Calc sheet navigation buttons on extreme left of Tab bar
Summary: Calc sheet navigation buttons on extreme left of Tab bar
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: UI (show other bugs)
Version:
(earliest affected)
5.0.0.5 release
Hardware: All All
: medium enhancement
Assignee: Not Assigned
URL:
Whiteboard: target:5.1.0 target:5.0.3
Keywords:
: 95180 (view as bug list)
Depends on:
Blocks: Sheet-Tabs-Bar
  Show dependency treegraph
 
Reported: 2015-08-10 09:24 UTC by Alex
Modified: 2017-10-14 08:52 UTC (History)
9 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Alex 2015-08-10 09:24:39 UTC
Please get rid of the new + button to insert new sheets, or - at least - move it somewhere where it's less likely to get clicked by accident.  But, more important than that, please restore the two buttons which advanced to the beginning or end of the tab bar!  These changes are new "features" in version 5 whose efforts to implement would have been much better spent fixing some of the bugs in Calc, rather than messing with a User Interface that has been working fine for 20 years!
Comment 1 tommy27 2015-08-10 14:30:00 UTC
the user is ranting about this:
.......................................
https://wiki.documentfoundation.org/ReleaseNotes/5.0#General_UI_changes

see the "Improvements in Calc/Draw sheet tab controls"

The following changes were made by Tomaž Vajngerl (Collabora):

The scroll buttons in Calc have been reduced to two: First and Last are removed, and Previous and Next can assume the functions of First and Last when pressing the Ctrl key while clicking
.......................................

I do not like the tone of this bug report, however I think that an option to bring back the "First" and "Last" button could be considered.
Comment 2 Alex 2015-08-11 04:41:11 UTC
I did not intend any offense in the enhancement I submitted!  Please note that I said "please" before each request, and meant it genuinely!  However, I stand behind the opinion I expressed that scarce resources had been applied to the wrong priorities in this case.  I have been a heavy user of spreadsheets for over 30 years, the last 20 of which have been with the use of Excel 5.0 and its VBA - now over 20 years old. In spite of that, Excel 5 still does things that Calc doesn't do, and I would continue using it except I fear that at some point it will cease to work with a new OS.  Hence, I'm trying to migrate complex workbooks and hundreds of lines of VBA from Excel 5.0 to Calc.  It hasn't been easy.

Thanks for including the link to the new features in version 5 - I had not seen it.  I actually only went to version 5 two days ago when I learned that it fixed a deficiency/bug regarding Named Ranges for entire rows or columns that had caused me to previously write a macro which fixed what Calc destroyed every time a new row or column was added to a sheet with such NamedRanges.  I'm frustrated by the slow pace with which Calc is getting even with where MS was 20 years ago, but I understand that it is largely thanks to the kindness and generosity of so many volunteers that it is even as good as it is.  I'm grateful for that, and am trying to be patient while the backlog of deficiencies is dealt with!  

User Interfaces are an important part of working with any program, and Calc and the Basic IDE, in particular, have ample opportunities awaiting improvements.  The link in your response included a lengthy discussion about what to add to or remove from the standard toolbars.  What is done there is of no concern or use to me, because I always make my own customized toolbars.  I also can and do customize the menu bars.  But, as far as I last knew, I cannot customize the context (right-mouse-button) menu (as I can in Excel) to add a very much missed Excel option to insert a previously copied cell range (i.e., inserting the required number of new rows/columns and pasting the clipboard's content to that area) unless I write a macro to do it.  When I looked into the possibilities of doing just that, I found the whole technique of programmatically examining what is on the clipboard so daunting that I tabled it for another day when I had a lot of time to further investigate.  I mention this only as just one example of a User Interface enhancement that would, at least for me, truly add value.   There are many more.

I really fail to comprehend the reasons for the changes I "vented" about in the original submittal. If you have scores of sheets in a workbook, the utility of going quickly to the beginning or end of that tab sequence is used frequently.  Requiring two hands (Ctrl + mouse-click) should never be a requirement for any request (an alternate short-cut maybe, but never required).  If those two button controls were removed to make way for another ability to add a new sheet, then the trade-off was flawed.  How difficult is it to right-click anywhere on the tab bar to pop-up a window giving you the option of saying how many new sheets you want, where to put them, and what name to call them?  How many times do people add sheets in the first place, nor not want to give them a name besides "Sheet_" when they do?  If there are users craving such a button, then I wouldn't want to deny them that wish; but, not if a required  tradeoff is the loss of the "First Sheet" and "Last Sheet" buttons.   If you keep the new sheets button, then at least place it at the other end of the tab bar, where it won't get confused with the scroll buttons and clicked accidentally.   Please note that if I could fix this myself for my own desires, I would, but as far as I know, I can't customize the tab bar controls to add back what someone else decided was superfluous and removed.

I'm sorry if the tone of this addendum is also unwelcome, but please understand that I have been spending an enormous amount of time and effort trying to work around Calc's relative deficiencies and slower performance, and having a feature I use frequently taken away while so many real opportunities to add value remain in queue, is not something I welcome!  Any developers who have time on their hands should go tackle the Basic IDE User Interface!  It's barely adequate to enable the creation of Basic macros, dialogs and the testing thereof, and certainly not anything you'd want to spend much time having to use.  But, on the positive side, I will say it's a lot better than where it was 5 years ago when I first took a look at it and decided it wasn't yet ready for real use.  So, progress does happen!  But, the removal of the "First-" and "Last-Sheet" controls was not progress!
Comment 3 Tomaz Vajngerl 2015-08-15 13:58:57 UTC
It is not about offense but if we should take you seriously or not. I usually listen to users and try to find a compromise that would work for them but I don't take any user seriously that ends every sentence with an exclamation mark or has a passive-aggressive tone.

(In reply to Alex from comment #2)
> I did not intend any offense in the enhancement I submitted!  Please note
> that I said "please" before each request, and meant it genuinely!  However,
> I stand behind the opinion I expressed that scarce resources had been
> applied to the wrong priorities in this case.  

I worked on this in my free time to improve the tab bar in Calc so instead of this I could go running or climbing instead, so no resources were wasted.  There are also no priorities for "features" in LO. Volunteers work on things they find interesting.  

> I really fail to comprehend the reasons for the changes I "vented" about in
> the original submittal. If you have scores of sheets in a workbook, the
> utility of going quickly to the beginning or end of that tab sequence is
> used frequently.  Requiring two hands (Ctrl + mouse-click) should never be a
> requirement for any request (an alternate short-cut maybe, but never
> required).  If those two button controls were removed to make way for
> another ability to add a new sheet, then the trade-off was flawed.  How
> difficult is it to right-click anywhere on the tab bar to pop-up a window
> giving you the option of saying how many new sheets you want, where to put
> them, and what name to call them?  How many times do people add sheets in
> the first place, nor not want to give them a name besides "Sheet_" when they
> do?  If there are users craving such a button, then I wouldn't want to deny
> them that wish; but, not if a required  tradeoff is the loss of the "First
> Sheet" and "Last Sheet" buttons.   If you keep the new sheets button, then
> at least place it at the other end of the tab bar, where it won't get
> confused with the scroll buttons and clicked accidentally.   Please note
> that if I could fix this myself for my own desires, I would, but as far as I
> know, I can't customize the tab bar controls to add back what someone else
> decided was superfluous and removed.

Now that scrollbar is in a different position and sheets have a lot of space, the need for this buttons has decreased so this was my reason to remove them or better - combine the functions into "Left", "Right" buttons. Instead of "ctrl + mouse click" I could make it a "double click" if this is a solution to the rant.

The "add new sheet" button was moved from "Right" because it was implemented as a hack with a new sheet and was not a real button before. Now on the right it is also in a consistent place and not hidden from the user. 

> Any
> developers who have time on their hands should go tackle the Basic IDE User
> Interface!

No, thank you.

Anyway, I'll change what the UX team decides we should do about this.
Comment 4 tommy27 2015-08-15 14:16:17 UTC
(In reply to Tomaz Vajngerl from comment #3)
> It is not about offense but if we should take you seriously or not. I
> usually listen to users and try to find a compromise that would work for
> them but I don't take any user seriously that ends every sentence with an
> exclamation mark or has a passive-aggressive tone.
> 
> (In reply to Alex from comment #2)
> ...
> 
> I worked on this in my free time to improve the tab bar in Calc so instead
> of this I could go running or climbing instead, so no resources were wasted.
> ...

your work has to be appreciated like all your other contributions to LibO and as I said before I really did not like the tone of this rant.


> Now that scrollbar is in a different position and sheets have a lot of
> space, the need for this buttons has decreased so this was my reason to
> remove them or better - combine the functions into "Left", "Right" buttons.
> Instead of "ctrl + mouse click" I could make it a "double click" if this is
> a solution to the rant.
> 
> ...

I think that "double-click" instead of "ctrl + mouse click" would be a perfect compromise.

double clicking is a faster and one-hand-only solution and is much intuitive than ctrl+mouse
Comment 5 Alex 2015-08-16 10:51:52 UTC
I can live with the "double-click" proposal; however, I'm not used to double-clicking on such controls, so without being told that such a feature existed I might never discover it.  What might be better, if it's possible, is to have double-clicking advance the tabs an entire screen-width, rather than just one tab; and to have a tripple-click advance to the beginning or end, as appropriate.
Comment 6 tommy27 2015-08-16 15:17:29 UTC
(In reply to Alex from comment #5)
> I can live with the "double-click" proposal; however, I'm not used to
> double-clicking on such controls, so without being told that such a feature
> existed I might never discover it.  

User should Read release notes to Learn about new features
Comment 7 Adolfo Jayme 2015-08-16 16:52:45 UTC
I like the new position of the plus button, because you don’t have to chase it with the mouse anymore every time you click it (this is the same reason why the New Tab button in Google Chrome doesn’t move off your mouse until you’re done with it).

On the double-click-versus-Ctrl-clicking issue, I have no preference, but the current behavior works fine, and I don’t think this bug report has a good rationale to change it.
Comment 8 tommy27 2015-08-16 17:57:42 UTC
@Adolfo

I agree about the "plus" button.

but regarding the "double-click" vs "Ctrl+Click" I still think that the we should change the behaviour since "double-click" is a rapid one-hand-only action while "Ctrl+Click" needs two hands and in many cases also visual checking where the Ctrl key is.

so I see the "double click" a more efficient and intuitive way to achieve the "last sheet" and "first sheet" actions.

so IMHO we should reserve WONTFIX just for the "plus" button issue, while the first/last sheet action should be considered for a change.

according to what Tomaz said in comment 3 it is very easy to change the code to accomplish this.
Comment 9 Yousuf Philips (jay) (retired) 2015-08-16 19:26:19 UTC
So here are some suggestions.

1) As the first and last buttons have been wrapped up in the previous and next buttons, the previous and next buttons should have a tooltip stating this possibility of ctrl+click.

2) As the previous and next buttons work with click and click + hold, double-click shouldnt likely be the option for first and last, as some users who dont know that click + hold works will likely rapidly click thinking that will move it faster.

Personally speaking, i do like the new position of the plus button so that its not constantly jumping around, but dont see the advantage of removing the first and last buttons, especially now that since 4.4 the sheet tabs are separated from the horizontal scrollbar.
Comment 10 Jean-Baptiste Faure 2015-08-17 04:37:03 UTC
I do not have advice about ctrl+click vs. double click but I think a tooltip giving the action and the shortkey is missing for each of these three buttons.

Best regards. JBF
Comment 11 Heiko Tietze 2015-08-17 06:42:03 UTC
I vote for individualization in terms of a menu option '[x] Fix position' for the add sheet and '[ ] Show first/last button' at then left/right buttons. 

Both ctrl+click and double-click have disadvantages. The double click is weird on buttons, accelerate with ctrl is kind of an easter egg. So no preference here from my side.

BTW: In my current installation 5.0.0.5 on Windows the left/right buttons do not work at all. And the context menu for these buttons expands down below the screen bottom, mostly. Please check if it's a non-standard implementation (might be a Windows bug as well).
Comment 12 Jean-Baptiste Faure 2015-08-17 07:08:11 UTC
(In reply to Heiko Tietze from comment #11)
> [...]
> BTW: In my current installation 5.0.0.5 on Windows the left/right buttons do
> not work at all.

These buttons do something only in the case where there is not enough room to see all tabs.

Best regards. JBF
Comment 13 Heiko Tietze 2015-08-17 07:13:51 UTC
(In reply to Jean-Baptiste Faure from comment #12)
> These buttons do something only in the case where there is not enough room
> to see all tabs.
OMG! Why not have it always active? (Hope this question is not too much OT)
Comment 14 tommy27 2015-08-17 13:14:58 UTC
@Tomaz
looking at the code you modified it would be easier to bring back the "last" and "first" sheet buttons like it was in 4.4.x or make it optional to see them or not?
Comment 15 V Stuart Foote 2015-09-18 17:49:26 UTC
*** Bug 94171 has been marked as a duplicate of this bug. ***
Comment 16 Commit Notification 2015-10-14 20:40:27 UTC
Tomaž Vajngerl committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=b6fe593c8a60cc689e1bbb4d92d7cad89785be0d

tdf#93318 reintroduce first/last button in Calc tab bar

It will be available in 5.1.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 17 Yan Pas 2015-10-14 20:43:30 UTC
Can you provide screenshots please? Is what was mentioned in bug 94171 ?
Comment 18 Tomaz Vajngerl 2015-10-14 21:29:05 UTC
Hi Yan,


The commit here just brings first/last button back as the main complaint was in this bug. Your bugs may not be so similar afterall.

Tomaž
Comment 19 Luke 2015-10-15 00:59:15 UTC
Tomaž, 

Why did you reject Yousuf's solution? 

> 1) As the first and last buttons have been wrapped up in the previous and next buttons, the previous and next buttons should have a tooltip stating this possibility of ctrl+click.


I work with large spreadsheets, and I'd prefer 2 larger buttons over 4 tiny ones. In fact one minor annoyance I have always had with Calc is I sometimes mis-click trying to click those microscopic buttons. Two big buttons are much better.I'd prefer to control-click, but it would be ok with double clicking too. 


The other issue about the "+" being in the wrong spot is a valid one. From web browsers to other spreadsheets, the "+" is always at the end of the tabs. You go to the end to add more, and it's too easy to mis-click next to the back/forward buttons.
Comment 20 V Stuart Foote 2015-10-15 03:18:46 UTC
(In reply to Luke from comment #19)
> Why did you reject Yousuf's solution? 
> 

Huh? He didn't... from Jay's same comment 9

"... but dont see the advantage of removing the first and last buttons, especially now that since 4.4 the sheet tabs are separated from the horizontal scrollbar."
 
So Tomaž simply added them back. Thank you Tomaž by the way.

So now we again have  --First | Left | Right | Last-- instead of the <Ctrl>+click or double-click of the Left | Right buttons. And, the sheet navigation buttons remain inactive until the count of tabs extends across the width of the document area.

Guess we could suppress the sheet navigation buttons while they are inactive--leaving just the "Plus" button active positioned at the start of the sheet tabs.

As to position of the Add-sheet "Plus" button, I find that pinned to the right of the sheet navigation buttons is a comfortable spot -- better than at the end of the sheet tabs where it would otherwise jump further right as sheets are added.

Maybe what would make folks more comfortable with the fixed left edge position would be some space between the sheet navigation arrows and the "Plus" button. Wouldn't need much, just enough to keep from clicking unintentionally.

But to my mind that is totally up to Tomaž, who otherwise should go running or climbing while the weather remains nice :-)
Comment 21 Luke 2015-10-15 07:50:16 UTC
> As to position of the Add-sheet "Plus" button, I find that pinned to the right of the sheet navigation buttons is a comfortable spot

All of those buttons are tiny and easy to mis-click, as described in the original description. I agree with Alex here.  If you've ever used any tabbed interface this is how they nearly all work. See every web browser for examples. So the user expects the "+" at the end away from the navigation buttons. You don't want the user accidentally adding tabs when they are trying to navigate. This is why web browsers put it at the end, and we should do the same.

Tomaž, 
Has bring back these unnecessary buttons been discussed by the UX team? We've been doing a great job of cleaning up the overly cluttered UI. Going back to 4 buttons is a step backwards.
Comment 22 tommy27 2015-10-15 08:26:05 UTC
I do not agree with Luke. 
I like the last and first button and I'm happy that Tomaz brought them back.

the best thing would be an option to customize which buttons to show and in which position just like in regular toolbars

this way every user would be pleased and nobody will never rant again.

if you remove buttons, those who like them will be annoyed
if you bring them back, those who don't like them will be annoyed


the only asnwer is allowing full customization
Comment 23 Luke 2015-10-15 11:54:48 UTC
The decision should be made by the UX team. If we accepted every bug report like this one asking for the classic behavior, our UI would never change. 

Instead of all of this talk, I'd love to see actual usage stats. With the new 5.0 UI, I need to be working in spreadsheets with over 20 sheets for the first/last button useful. I've seen thousands of spreadsheets in my life, and 20+ sheets is the exception, NOT the rule.

And spreadsheet power users like our accounts barely touch the mouse. They get around with CTRL+Page Up/Down. 

Unless stats show otherwise, these 2 buttons are only good for cluttering up our UI. Yousuf's proposal was the right solution.
Comment 24 tommy27 2015-10-15 12:03:28 UTC
I insist that customization is the right solution.

I don't care if you are a power user or a newbie.
the best interface is a flexible and customizable one that allows to show/hide the buttons you need.
Comment 25 V Stuart Foote 2015-10-15 14:30:20 UTC
@Tomaž, *

With todays TB62 build...
Version: 5.1.0.0.alpha1+
Build ID: 4b55c28940d741e53648115a9cfb58f2d6db38a5
TinderBox: Win-x86@62-merge-TDF, Branch:MASTER, Time: 2015-10-15_06:14:50
Locale: en-US (en_US)

Nice touch on the active/inactive state of the sheet navigation, and the current padding on "plus" button works well. Thank you!

That is good enough, going to call it done! Resolved Fixed from UX team perspective. On to tougher nuts to crack...

http://cgit.freedesktop.org/libreoffice/core/commit/?id=b6fe593c8a60cc689e1bbb4d92d7cad89785be0d
Comment 26 Commit Notification 2015-10-15 14:57:56 UTC
Tomaž Vajngerl committed a patch related to this issue.
It has been pushed to "libreoffice-5-0":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=6894ebffe4154887fd8b2521b5c5d1980dfe9e62&h=libreoffice-5-0

tdf#93318 reintroduce first/last button in Calc tab bar

It will be available in 5.0.4.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 27 Commit Notification 2015-10-15 16:23:40 UTC
Tomaž Vajngerl committed a patch related to this issue.
It has been pushed to "libreoffice-5-0-3":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=73e9281cbc146df12a3026c1521f1b458806e59e&h=libreoffice-5-0-3

tdf#93318 reintroduce first/last button in Calc tab bar

It will be available in 5.0.3.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 28 tommy27 2015-10-15 16:32:14 UTC
5.0 release notes have to be updated?
Comment 29 V Stuart Foote 2015-10-15 17:16:10 UTC
(In reply to tommy27 from comment #28)
> 5.0 release notes have to be updated?

Done.  But probably need an entry with the tdf#93318 ID added to the 5.0.3 RC2 notes, think that is automatic.
Comment 30 Luke 2015-10-16 22:53:48 UTC
> Fixed from UX team perspective.

If the UX team feels that cluttering up the UI with 2 buttons that are unnecessary 99.99% of the time, they are moving in the wrong direction. 

Also the original issue that the "+" is next to the navigation buttons is also not resolved. 

I insist that this is not fixed.
Comment 31 V Stuart Foote 2015-10-16 23:25:26 UTC
@Luke, it has been RESOLVED FIXED please set it back and accept the consensus view on both aspects. Alternative is RESOLVED WONTFIX but that becomes rude. 

The volunteer dev who elected to work on this facet of the UI has said his piece and made his code contributions--acceptable to all the Design/UX-Advise folks who have commented. So please, we need to move on.
Comment 32 tommy27 2015-10-17 02:34:35 UTC
.
Comment 33 tommy27 2015-10-17 03:31:26 UTC
submitted this enhancement request
Bug 95122 - option to selectively show/hide Calc sheet navigation buttons
Comment 34 V Stuart Foote 2015-10-19 16:31:17 UTC
*** Bug 95180 has been marked as a duplicate of this bug. ***